const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Historico_alteracoes_projetoDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const historico_alteracoes_projeto =
      await db.historico_alteracoes_projeto.create(
        {
          id: data.id || undefined,

          data_alteracao: data.data_alteracao || null,
          tipo_alteracao: data.tipo_alteracao || null,
          descricao_anterior: data.descricao_anterior || null,
          descricao_nova: data.descricao_nova || null,
          motivo_alteracao: data.motivo_alteracao || null,
          responsavel_alteracao: data.responsavel_alteracao || null,
          comentarios: data.comentarios || null,
          importHash: data.importHash || null,
          createdById: currentUser.id,
          updatedById: currentUser.id,
        },
        { transaction },
      );

    await historico_alteracoes_projeto.setEstrutura(data.estrutura || null, {
      transaction,
    });

    await historico_alteracoes_projeto.setClientes(data.clientes || null, {
      transaction,
    });

    return historico_alteracoes_projeto;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const historico_alteracoes_projetoData = data.map((item, index) => ({
      id: item.id || undefined,

      data_alteracao: item.data_alteracao || null,
      tipo_alteracao: item.tipo_alteracao || null,
      descricao_anterior: item.descricao_anterior || null,
      descricao_nova: item.descricao_nova || null,
      motivo_alteracao: item.motivo_alteracao || null,
      responsavel_alteracao: item.responsavel_alteracao || null,
      comentarios: item.comentarios || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const historico_alteracoes_projeto =
      await db.historico_alteracoes_projeto.bulkCreate(
        historico_alteracoes_projetoData,
        { transaction },
      );

    // For each item created, replace relation files

    return historico_alteracoes_projeto;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const historico_alteracoes_projeto =
      await db.historico_alteracoes_projeto.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.data_alteracao !== undefined)
      updatePayload.data_alteracao = data.data_alteracao;

    if (data.tipo_alteracao !== undefined)
      updatePayload.tipo_alteracao = data.tipo_alteracao;

    if (data.descricao_anterior !== undefined)
      updatePayload.descricao_anterior = data.descricao_anterior;

    if (data.descricao_nova !== undefined)
      updatePayload.descricao_nova = data.descricao_nova;

    if (data.motivo_alteracao !== undefined)
      updatePayload.motivo_alteracao = data.motivo_alteracao;

    if (data.responsavel_alteracao !== undefined)
      updatePayload.responsavel_alteracao = data.responsavel_alteracao;

    if (data.comentarios !== undefined)
      updatePayload.comentarios = data.comentarios;

    updatePayload.updatedById = currentUser.id;

    await historico_alteracoes_projeto.update(updatePayload, { transaction });

    if (data.estrutura !== undefined) {
      await historico_alteracoes_projeto.setEstrutura(
        data.estrutura,

        { transaction },
      );
    }

    if (data.clientes !== undefined) {
      await historico_alteracoes_projeto.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return historico_alteracoes_projeto;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const historico_alteracoes_projeto =
      await db.historico_alteracoes_projeto.findAll({
        where: {
          id: {
            [Op.in]: ids,
          },
        },
        transaction,
      });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of historico_alteracoes_projeto) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of historico_alteracoes_projeto) {
        await record.destroy({ transaction });
      }
    });

    return historico_alteracoes_projeto;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const historico_alteracoes_projeto =
      await db.historico_alteracoes_projeto.findByPk(id, options);

    await historico_alteracoes_projeto.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await historico_alteracoes_projeto.destroy({
      transaction,
    });

    return historico_alteracoes_projeto;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const historico_alteracoes_projeto =
      await db.historico_alteracoes_projeto.findOne({ where }, { transaction });

    if (!historico_alteracoes_projeto) {
      return historico_alteracoes_projeto;
    }

    const output = historico_alteracoes_projeto.get({ plain: true });

    output.estrutura = await historico_alteracoes_projeto.getEstrutura({
      transaction,
    });

    output.clientes = await historico_alteracoes_projeto.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.estrutura_projeto,
        as: 'estrutura',

        where: filter.estrutura
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.estrutura
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  etapa: {
                    [Op.or]: filter.estrutura
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.tipo_alteracao) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'historico_alteracoes_projeto',
            'tipo_alteracao',
            filter.tipo_alteracao,
          ),
        };
      }

      if (filter.descricao_anterior) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'historico_alteracoes_projeto',
            'descricao_anterior',
            filter.descricao_anterior,
          ),
        };
      }

      if (filter.descricao_nova) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'historico_alteracoes_projeto',
            'descricao_nova',
            filter.descricao_nova,
          ),
        };
      }

      if (filter.motivo_alteracao) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'historico_alteracoes_projeto',
            'motivo_alteracao',
            filter.motivo_alteracao,
          ),
        };
      }

      if (filter.responsavel_alteracao) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'historico_alteracoes_projeto',
            'responsavel_alteracao',
            filter.responsavel_alteracao,
          ),
        };
      }

      if (filter.comentarios) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'historico_alteracoes_projeto',
            'comentarios',
            filter.comentarios,
          ),
        };
      }

      if (filter.data_alteracaoRange) {
        const [start, end] = filter.data_alteracaoRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            data_alteracao: {
              ...where.data_alteracao,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            data_alteracao: {
              ...where.data_alteracao,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } =
        await db.historico_alteracoes_projeto.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('historico_alteracoes_projeto', 'tipo_alteracao', query),
        ],
      };
    }

    const records = await db.historico_alteracoes_projeto.findAll({
      attributes: ['id', 'tipo_alteracao'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['tipo_alteracao', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.tipo_alteracao,
    }));
  }
};
